routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
  |--------------------------------------------------------------------------
  | Web Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register web routes for your application. These
  | routes are loaded by the RouteServiceProvider within a group which
  | contains the "web" middleware group. Now create something great!
  |
 */
Auth::routes();

Route::get('/', 'HomeController@index')->name('home.index');
Route::get('/registerc', 'Auth\RegisterController@registerc')->name('register.registerc');
//Route::resource('users', 'UserController')->middleware('auth');
//Route::get('categoriasu', 'CategoriasUserController@index');

Route::get('recuperarpassword/{hash}', 'Auth\ResetPasswordController@resetpassword')->name('user.resetpassword');
Route::post('enviarlink/password', 'Auth\ResetPasswordController@resetpasswordhash')->name('usuario.sendlinkpassword');
Route::post('actualizar/password', 'Auth\ResetPasswordController@updatepassword')->name('usuario.updatepassword');

Route::middleware(['auth'])->group(function () {

    /* Route::get('inicio', function () {
      return view('welcome');
      })->name('inicio'); */

    Route::resource('users', 'UserController'); //CRUD
    Route::resource('categoriasu', 'CategoriasUserController'); //CRUD s
    Route::resource('productos', 'ProductoController'); //CRUD
    Route::resource('links', 'LinkController'); //CRUD

    Route::post('productos/{producto}/duplicate', 'ProductoController@duplicate')->name('productos.duplicate');

    Route::post('productos/{producto}/linkear', 'ProductoController@linkear')->name('productos.linkear');

    Route::resource('configuracion', 'ConfiguracionController'); //CRUD

    Route::get('cargamasiva', 'CargaMasivaController@index')->name('cargamasiva.index');
    Route::get('cargamasiva/plantilla', 'CargaMasivaController@downloadtemplate')->name('cargamasiva.template');
    Route::post('cargamasiva/procesar', 'CargaMasivaController@process')->name('cargamasiva.proccess');

    Route::get('cargamasiva/users', 'CargaMasivaController@indexusers')->name('userscargamasiva.index');
    Route::get('cargamasiva/plantilla/usuarios', 'CargaMasivaController@downloadtemplateusers')->name('cargamasivausers.template');
    Route::post('cargamasiva/procesar/usuarios', 'CargaMasivaController@processusers')->name('cargamasivausers.proccess');

    Route::get('soporte/create', 'SoporteController@create')->name('soporte.create');
    Route::post('soporte/create/process', 'SoporteController@createprocess')->name('soporte.createprocess');

    Route::get('datosbancarios', 'DatosBancariosController@create')->name('datosbancarios.create');
    Route::post('datosbancarios/create/procesar', 'DatosBancariosController@createprocess')->name('datosbancarios.createprocess');
    Route::get('datosbancarios/{users}', 'DatosBancariosController@show')->name('datosbancarios.show');

    //Route::get('users', 'UserController@linkpago')->name('users.linkpago');

    Route::get('perfil/edit', 'PerfilController@edit')->name('perfil.edit');
    Route::post('perfil/edit/process', 'PerfilController@editprocess')->name('perfil.editprocess');

    Route::post('perfil/edit/setshopify', 'PerfilController@setshopify')->name('perfil.setshopify');

    Route::post('users/{user}/updateurl', 'UserController@updateurl')->name('users.updateurl');

    Route::get('pagos/', 'PagosController@index')->name('pagos.index');
    Route::post('pagos/spa', 'PagosController@spa')->name('pagos.spa');
    Route::post('pagos/spl', 'PagosController@spl')->name('pagos.spl');
    Route::get('pagos/{pagos}/edit', 'PagosController@edit')->name('pagos.edit');
    Route::put('pagos/{pagos}/update', 'PagosController@update')->name('pagos.update');
    //Route::get('categoriasComercios/{cc}', 'CategoriasUserController@show')->name('categoriasComercios');

    Route::post('categoriaproducto/create', 'CategoriascController@create')->name('categoriaproductos.create');
    Route::post('categoriaproducto/eliminar', 'CategoriascController@eliminar')->name('categoriaproductos.delete');
});

//Route::resource('users', 'UserController');
//Route::get('users','UserController@index');
//Route::post('users','UserController@store')->name('users.store');
//Route::delete('users/{user}','UserController@destroy')->name('users.destroy');

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable {

    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password', 'url_perfil', 'ciudad', 'direccion', 'telefono', 'cc_id', 'sitio_web', 'quien_es', 'redes1', 'redes2', 'redes3', 'estado', 'password_reset', 'url_pago'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function categoriacomercio() {
        return $this->belongsTo(CategoriasComercios::class, 'cc_id');
    }

    public function getGetNameAttribute() {
        return strtoupper($this->name);
    }

    /* public function setNameAttribute($value)
      {
      $this->attributes['name'] = strtoupper($value);
      } */

    public function setPasswordAttribute($value) {
        $this->attributes['password'] = bcrypt($value);
    }

    public function getFormatFechaAttribute() {
        return $this->created_at->format('d M Y');
    }

    public function getImagenAttribute() {
        return '<img src="' . url('storage/app/public/' . $this->url_perfil) . '" alt="user" class="img-circle" style="width: 150px; height: 131px;display: block;margin-bottom: 30px;">';
    } 

    public function getImagenlistAttribute() {
        if (!empty($this->url_perfil)) {
            return '<img src="' . url('storage/app/public/' . $this->url_perfil) . '" alt="user" class="img-circle float-left m-r-10" style="width: 30px; height: 30px;">';
        } else {
            return '<img src="https://ubisoft-avatars.akamaized.net/a3c1a636-db47-4751-941b-1acc538932de/default_256_256.png" alt="user" class="img-circle float-left m-r-10" style="width: 30px; height: 30px;">';
        }
    }

    public function getEstadosAttribute() {
        return ($this->estado == 'I') ? '<span style="color: #929292">Inactivo</span>' : '<span style="color: #432874">Activo</span>';
    }

    public function productos() {
        return $this->hasMany(Productos::class, 'users_id');
    }

    public function linkeados() {
        return $this->hasMany(Links::class, 'users_id');
    }

}

app/Http/Controllers/Api/UserController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\User;
//use Illuminate\Http\Request;
use App\Http\Requests\UserRequest;

class UserController extends Controller
{

    protected $user;

    public function _construct(User $user)
    {
        $this->user = $user;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    { 
        //
        $users = User::
        //->where('id', '>=', '20')
        orderBy('users.id','DESC')
        //->take()
        ->get();

        return response()->json($users, 200);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(UserRequest $request)
    {
        //
        //$user = $this->user->create($request->all());

        return response()->json($user, 201);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\User  $user
     * @return \Illuminate\Http\Response
     */
    public function show(User $user)
    {
        //
        return response()->json($user);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\User  $user
     * @return \Illuminate\Http\Response
     */
    public function update(UserRequest $request, User $user)
    {
        //
        $post->update($request->all());
        
        return response()->json($post);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\User  $user
     * @return \Illuminate\Http\Response
     */
    public function destroy(User $user)
    {
        //
        //$post->delete();

        return response()->json(null, 204);
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\User;
use App\CategoriasComercios;
use Illuminate\Http\Request;
use App\Http\Requests\UserRequest;

use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Auth;

class UserController extends Controller
{

    public function _construct()
    {
        //$this->middleware('auth');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $users = User::withCount('productos')
        //->where('id', '>=', '20')
        ->orderBy('users.id','DESC')
        //->take()
        ->get();

        //https://laravel.com/docs/7.x/eloquent-collections
        //->all()
        //->find(4)
        //->load('categoriacomercio')
        //->toArray()
        //->toJson()
        //->with('categoriacomercio')
        
        return view('users.index', compact('users'));

        /*return view('users.index', [
            'users' => $users
        ]);*/
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $cc = CategoriasComercios::
        //->where('id', '>=', '20')
        orderBy('id','DESC')
        //->take()
        ->get();

        return view('users.create', [ 'cc' => $cc ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(UserRequest $request)
    {
        //
        //dd($request->all());
        /*
        $request->validate([
            'name'      => 'required',
            'email'     => ['required','email','unique:users'],
            'password'  => ['required','min:8']
        ]);*/
        
        /*$user = User::create([
            //'user_id' => auth()->user()->id //para registrar el id del usuario login
            'name' => $request->name,
            'email' => $request->email,
            'password' => bcrypt($request->password)
        ]);*/

        $user = User::create($request->all());

        //imagen
        if($request->file('url_perfil')) {
            $user->url_perfil = $request->file('url_perfil')->store('users', 'public');
            $user->save();
        }

        return back()->with('status', 'Creado con éxito.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\User  $user
     * @return \Illuminate\Http\Response
     */
    public function show(User $user)
    {
        //
        if(Auth::user()->cc_id == 1) {// si es un comerciante
            if($user->id == Auth::user()->id) 
                return view('users.view', ['user' => $user]);
            else
                return view('users.aviso', ['user' => $user]);
        } else if(Auth::user()->cc_id == 2) { //es un afiliado
            if($user->id == Auth::user()->id) 
                return view('users.view', ['user' => $user]);
            else
                return view('users.aviso', ['user' => $user]);
        } else {
            return view('users.view', ['user' => $user]);
        }
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\User  $user
     * @return \Illuminate\Http\Response
     */
    public function edit(User $user)
    {
        //  
        //dd($user);
        if(Auth::user()->cc_id == 1 || Auth::user()->cc_id == 2) {
            if($user->id != Auth::user()->id)
                return view('users.aviso');
        }

        $cc = CategoriasComercios::
        //->where('id', '>=', '20')
        orderBy('id','DESC')
        //->take()
        ->get();
        
        return view('users.edit', ['user' => $user, 'cc' => $cc ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\User  $user
     * @return \Illuminate\Http\Response
     */
    public function update(UserRequest $request, User $user)
    {
        //dd($request->cc_id);
        //
        /*if(!empty($request->password)) {
            if($request->password != $request->password_confirmation){
                return back()->errors()->add('event', 'La contraseña no son iguales.');
            }
        }*/

        $user->update($request->all());

        //imagen
        if($request->file('url_perfil_new')) {
            //eliminar imagen
            Storage::disk('public')->delete($user->url_perfil);
            $user->url_perfil = $request->file('url_perfil_new')->store('users', 'public');
            $user->save();
        }

        return redirect()->route('users.edit', $user)->with('status', 'Actualizado con éxito.');
    } 

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\User  $user
     * @return \Illuminate\Http\Response
     */
    public function destroy(User $user)
    {
        //
        Storage::disk('public')->delete($user->url_perfil);
        $user->delete();

        return back()->with('status', 'Se elimino cliente con éxito.');  
    }

    public function updateurl(Request $request)
    {        
        $user = User::find(Auth::user()->id);
        // Make sure you've got the Page model
        if($user) {
            $user->url_pago = $request->input('url_pago');
            $user->save();
        }

        return redirect()->route('perfil.edit')->with('status', 'Se actualizo el link de pago correctamente.');  
    }
}

resources/views/users/aviso.blade.php
<h2>Esta ingresando a una pagina no autorizada</h2>

resources/views/users/create.blade.php
@extends('layout') 
@section('content')
<div class="row page-titles">
    <div class="col-md-5 align-self-center">
        <h3 class="text-themecolor">Crear Cliente</h3>
    </div>
    <div class="col-md-7 align-self-center">
        <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="{{route('users.index')}}">Clientes</a></li>
            <li class="breadcrumb-item active">Nueva cliente</li>
        </ol>
    </div>
    <div>
        <button class="right-side-toggle waves-effect waves-light btn-inverse btn btn-circle btn-sm pull-right m-l-10"><i class="ti-settings text-white"></i></button>
    </div>
</div>

<div class="container-fluid">   

    @if($errors->any())
    <div class="card border-0 shadow">
        <div class="card-body">
            <div class="alert alert-danger">
                @foreach($errors->all() as $error)
                - {{ $error }} <br/>
                @endforeach
            </div>
        </div>
    </div>
    @endif

    <div class="row"> 
        <div class="col-lg-12">
            <form action="{{ route('users.store') }}" method="POST" class="form-horizontal" enctype="multipart/form-data">
                <div class="card card-outline-info">
                    <div class="card-body">
                        <div class="form-body">
                            <h6 class="box-title">Ingrese los siguiente datos</h6>
                            <hr class="m-t-0 m-b-40">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Nombre</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="name" value="{{ old('name') }}" required>
                                        </div>
                                    </div> 
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Categoria</label>
                                        <div class="col-md-8">
                                            <select class="form-control custom-select" name="cc_id" required>
                                                @foreach($cc as $item)
                                                <option value="{{$item->id}}" @if( $item->id == old('cc_id') ) {!! _('selected') !!} @endif >{{$item->nombre_cc}}</option>
                                                @endforeach
                                            </select>
                                        </div>
                                    </div> 
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Ciudad</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="ciudad" value="{{ old('ciudad') }}" required>
                                        </div>
                                    </div>
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Dirección</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="direccion" value="{{ old('direccion') }}" required>
                                        </div>
                                    </div> 
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Teléfono</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="telefono" value="{{ old('telefono') }}" required>
                                        </div>
                                    </div>                                    
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Sitio Web</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="sitio_web" value="{{ old('sitio_web') }}" required>
                                        </div>
                                    </div> 
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Estado</label>
                                        <div class="col-md-8">
                                            <select class="form-control custom-select" name="estado" required>
                                                <option value="A" selected>Activo</option>
                                                <option value="I">InActivo</option>
                                            </select>
                                        </div>
                                    </div>   
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Contraseña</label>
                                        <div class="col-md-8 ">
                                            <input type="password" class="form-control" name="password" value="" required>
                                        </div>
                                    </div>          
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group row m-b-10">
                                        <label class="control-label text-right col-md-4">¿Quién es?</label>
                                        <div class="col-md-8">
                                            <textarea rows="5" class="form-control" name="quien_es" style="height: 111px;">{{ old('quien_es') }}</textarea>
                                        </div>
                                    </div>

                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Img.Perfil</label>
                                        <div class="col-md-8">
                                            <img class="previoFondo m-b-5" style="height: 105px; width: 105px; display: none;">
                                            <div class="file-field">
                                                <div class="btn btn-photo btn-sm">
                                                    <span><i class="fa-camera fa"></i></span>
                                                    <input type="file" class="form-control" id="imgFondo" name="url_perfil">
                                                </div>
                                            </div>                                          
                                        </div>
                                    </div> 

                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Facebook</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="redes1" value="{{ old('redes1') }}">
                                        </div>
                                    </div>

                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Instagram</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="redes2" value="{{ old('redes2') }}">
                                        </div>
                                    </div> 
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Youtube</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="redes3" value="{{ old('redes3') }}">
                                        </div>
                                    </div>
                                    <div class="form-group row">
                                        <label class="control-label text-right col-md-4">Correo</label>
                                        <div class="col-md-8 ">
                                            <input type="text" class="form-control" name="email"  value="{{ old('email') }}" required>
                                        </div>
                                    </div>                                    
                                </div>
                            </div>   
                        </div>                        
                    </div>
                </div>
                <div class="form-actions">
                    <div class="row">
                        <div class="col-md-12">
                            @csrf
                            <a href="{{route('users.index')}}" class="btn-md btn-inverse float-right">Cancelar</a>
                            <button type="submit" class="btn-md btn-primary float-right  m-r-10">Guardar</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

<style>
    .form-control{
        border-right: 1px solid #ced4da !important;
    }
</style>

<script>
    $(document).ready(function () {
        function readURL(input, doom) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();
                reader.onload = function (e) {
                    $('.' + doom).attr('src', e.target.result).show();
                }
                reader.readAsDataURL(input.files[0]);
                //$('.'+doom).val(input.files[0].name);              
            }
        }

        $("#imgFondo").change(function () {
            readURL(this, 'previoFondo');
        });
    });
</script>

@endsection

resources/views/users/index.blade.php
@extends('layout') 
@section('content')
<div class="container-fluid p-t-20">
    <div class="row">
        <div class="col-12">            
            <div class="card">
                <div class="card-body">
                    <h2 class="card-title">Clientes</h2>
                    <h6 class="card-subtitle">Lista de clientes</h6>
                    <div class="row">
                        <div class="col-md-12">
                            <a href="{{ route('users.create') }}" class="btn-md btn-primary float-left m-r-5 btn-especial">
                               Crear Usuario 
                            </a>
                            <a href="{{ route('userscargamasiva.index') }}" class="btn-md btn-primary float-left btn-especial">
                               Carga Usuarios 
                            </a>
                        </div>
                    </div>

                    <div class="table-responsive m-t-10">
                        <table id="myTable" class="tablesaw table-bordered table-hover table tablesaw-swipe tablesaw-sortable">
                            <thead>
                                <tr style="background: #ebebeb;">
                                    <th>ID</th>
                                    <th width="20">Usuario</th>
                                    <th>Tipo</th>
                                    <th>Productos</th>
                                    <th>Links</th>
                                    <th>Email</th>
                                    <th>Estado</th>
                                    <th width="10">Acciones</th>
                                </tr>
                            </thead>
                            <tbody>                             
                                @foreach($users as $user)
                                <tr>
                                    <td>{{ $user->id }}</td>
                                    <td width="20">{!! $user->imagenlist !!} <div class="float-left" style="width: 70%;">{{ $user->name }}</div></td>
                                    <td>{{ $user->categoriacomercio->nombre_cc }}</td>
                                    <td>{{ $user->productos_count }}</td>
                                    <td>{{ count($user->linkeados) }}</td>
                                    <td>{{ $user->email }}</td>
                                    <td>{!! $user->estados !!}</td>
                                    <td width="10" style="padding:0">
                                        <div class="btn-group" role="group" aria-label="But with nested dropdown">
                                            <!--
                                            <a href="{{ route('users.show', $user) }}" class="btn btn-secondary font-18 only-btn"><i class="fa fa-file-text-o"></i></a>
                                            -->

                                            <a href="{{route('users.edit', $user)}}" class="btn btn-secondary font-18 only-btn"><i class="fa fa-edit"></i></a>

                                            <form method="POST" action="{{ route('users.destroy', $user) }}">
                                                @method('DELETE')
                                                @csrf
                                                <button type="submit" value="Eliminar" class="btn btn-secondary font-18 only-btn" onclick="return confirm('Desea eliminar..?')"><i class="mdi mdi-delete"></i></button>
                                            </form>
                                        </div>
                                    </td>
                                </tr> 
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>            
        </div>
    </div>
</div>

<script src="../assets/plugins/datatables/jquery.dataTables.min.js"></script>
<script>
    $(document).ready(function() {
        $('#myTable').DataTable({
            "language": {
                "url": "//cdn.datatables.net/plug-ins/1.10.15/i18n/Spanish.json"           
            },
            "order": [
                [0, 'desc']
            ],
            "displayLength": 25,
            "columnDefs": [
                { "width": "20%", "targets": 1 },
                { "width": "20%", "targets": 5 }
            ]
        });       
    });  
</script>
<!--
<div class="row">
    <div class="col-sm-5">
        <div class="card border-0 shadow">
            <div class="card-body">
                @if($errors->any())
                <div class="alert alert-danger">
                    @foreach($errors->all() as $error)
                    - {{ $error }} <br/>
                    @endforeach
                </div>
                @endif
                <form action="{{ route('users.store') }}" method="POST">
                    <div class="row">
                        <div class="col-sm-12">
                            <input name="name" type="text" class="form-control" placeholder="Ingrese nombre completo" value="{{ old('name') }}">
                            @error('name')
                                <div class="alert alert-danger" role="alert">
                                    {{ $message }}
                                </div>
                            @enderror
                        </div>
                        <div class="col-sm-12">
                            <input name="email" type="text" class="form-control" placeholder="Ingrese el email" value="{{ old('email') }}">
                        </div>
                        <div class="col-sm-12">
                            <input name="password" type="password" class="form-control" placeholder="Ingrese el password">
                        </div>
                        <div class="col-12">
                            @csrf
                            <button type="submit" class="btn btn-primary">
                                Enviar
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>    
</div>
-->
@endsection    